#include <stdio.h>
#include <stdlib.h>

/*
 * This program simply gets a number from the user and displays the result.
 * Not particularly useful as a program, it demonstrates how you can get
 * numbers from the user.
 *
 * Everything the user enters will be text strings.
 * That is done by calling the gets (get string) routine,
 * passing a string array large enough to hold the user's response.
 *
 * The symbol BUFSIZ is defined in stdio.h and is set to the maximum
 * number of characters that the user can enter at one time.
 *
 * In order to perform arithmetic, you have to convert the string
 * to a number.  You usually do that by calling one of two routines:
 *      atoi - (ascii to integer) converts the string to an integer
 *      atof - (ascii to float) converts the string to a floating
 *              point number
 */
main()
{
    char buf[BUFSIZ]; /* input buffer for user's responses */
    int num; /* used to store the number the user will enter */

    printf("Enter an integer number: "); /* ask user for a number */
    gets(buf);  /* get response from user */
    num = atoi(buf); /* convert user's response to a number */
    printf("You entered %d\n", num); /* show user the results */

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
}
