#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* we use our own include file here, which defines NAMESIZ */
#include "getinfo.h"

/* function prototype for get_int */
int get_int(char buf[], char *msg);

main()
{
    char buf[BUFSIZ]; /* input area for user */
    char fname[NAMESIZ], lname[NAMESIZ]; /* storage area for first and last name */
    int age; /* variable for age */

    printf("Enter first name: "); /* ask for their first name */
    gets(buf); /* read response */
    strcpy(fname, buf); /* save their first name */

    printf("Enter last name: "); /* ask for their last name */
    gets(buf); /* read response from user */
    strcpy(lname, buf); /* save their last name */

    /* get age using get_int function */
    age = get_int(buf, "Enter your age: ");

    /*
     * We have all the information now, display it for the user to see
     */
    printf("Name: %s %s, age %d\n", fname, lname, age);

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
 }

 /*
  * This is the user defined function get_int
  * It prompts the user with a message, reads their response into buf,
  * and returns the integer value of the user's response
  */
int get_int(char buf[], char *msg)
{
    int ret;    /* return value */

    printf(msg);    /* prompt user for input with msg */
    gets(buf);      /* read response into array buf */
    ret = atoi(buf); /* convert response to integer */

    return ret; /* return numerical value */
 }
