#include <stdio.h>
#include <stdlib.h>
/* we need string.h for the strlen() function */
#include <string.h>
/* we need ctype.h for the isalpha(), etc. functions */
#include <ctype.h>

/*
 * This program reads a line of text from the user
 * It then analyzes the string, counting how many characters
 * fitting into one of several character types are found
 */

main()
{
    char buf[BUFSIZ];   /* input buffer for user's response */
    /* declare counters and initialize them to zero */
    int alpha=0, digit=0, space=0, punct=0, other=0, hex=0;
    int len, i;
    char c;

    /* get string from user */
    printf("Enter a line: ");
    gets(buf);

    len = strlen(buf);  /* length of string */

    /* now loop through the string */
    for (i=0; i < len; i++)
    { /* analyze this character */
        c = buf[i];     /* get the current character */
        /*
         * we could use buf[i] in the following expressions
         * I do the above to save me some typing.
         */
        if (isalpha(c))
        { /* alphabetic character */
            alpha++;    /* increment counter */
            if (isxdigit(c)) hex++;    /* also hex character */
        }
        else if (isdigit(c))
        { /* decimal digit (0 to 9) */
            digit++;    /* increment counter */
            hex++;      /* hexidecimal character as well */
        }
        else if (isspace(c)) space++;
        else if (ispunct(c)) punct++;
        else other++;   /* nothing else, must be other */
    }

    printf("You entered %d characters\n", len);
    printf("%4d Alphabetic\n%4d Digits\n%4d Hex Digits\n", alpha, digit, hex);
    printf("%4d Space\n%4d Punctuation\n%4d Others\n", space, punct, other);

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
 }
