VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   495
      Left            =   3120
      TabIndex        =   7
      Top             =   1560
      Width           =   1215
   End
   Begin VB.ComboBox cmbFind 
      Height          =   315
      Left            =   1560
      TabIndex        =   6
      Text            =   "Combo1"
      Top             =   1560
      Width           =   1455
   End
   Begin VB.TextBox txtFind 
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   1560
      Width           =   1215
   End
   Begin VB.ListBox lstFind 
      Height          =   1035
      Left            =   2400
      TabIndex        =   1
      Top             =   240
      Width           =   2000
   End
   Begin VB.ListBox lstList 
      Height          =   1035
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2000
   End
   Begin VB.Label lblStat 
      Alignment       =   2  'Center
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   2160
      Width           =   4215
   End
   Begin VB.Label Label3 
      Caption         =   "Search For:"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Search Result"
      Height          =   255
      Left            =   2400
      TabIndex        =   3
      Top             =   0
      Width           =   2055
   End
   Begin VB.Label Label1 
      Caption         =   "List to Search"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   0
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim FirstTime As Boolean
Dim NumEnts As Integer
Dim MaxNum As Integer
Dim KeyNum As Integer


Private Sub cmdFind_Click()
    find_entry
End Sub
Private Sub Form_Activate()
    If FirstTime Then init_form
End Sub
Private Sub Form_Load()
    FirstTime = True
End Sub
Sub init_form()
    NumEnts = 100
    MaxNum = 20
    
    Randomize   ' random numbers
    load_combo  ' load option list
    load_list   ' load list of numbers
    
    lblStat.Caption = "Enter number, select option, then press Find"
    
End Sub
Sub load_combo()
    cmbFind.AddItem "Find First"
    cmbFind.AddItem "Find Last"
    cmbFind.AddItem "Count Entries"
    cmbFind.AddItem "List Entries"
    
    cmbFind.ListIndex = 0   ' select first entry
End Sub
Sub load_list()
    Dim i As Integer
    Dim num As Integer
    
    lstList.Clear
    For i = 0 To NumEnts - 1
        num = Rnd * MaxNum
        lstList.AddItem "Loc " & i & ": " & num
        lstList.ItemData(i) = num
    Next
End Sub
Sub find_entry()
    Dim num As Integer
    
    ' Get number to search for
    KeyNum = Val(txtFind.Text)
    lstList.ListIndex = -1  ' unselect list
    
    ' get selected option
    num = cmbFind.ListIndex
    Select Case num
    Case Is = 0
        find_first
    Case Is = 1
        find_last
    Case Is = 2
        find_count
    Case Is = 3
        find_list
    Case Else
        MsgBox "Invalid option!"
    End Select
    
End Sub
Sub find_first()
    Dim num As Integer
    Dim i As Integer
    
    ' find first entry
    For i = 0 To NumEnts - 1
        num = lstList.ItemData(i)
        If num = KeyNum Then
            ' match found
            lstList.ListIndex = i
            lblStat.Caption = "Entry found at location " & i
            Exit Sub
        End If
    Next

    ' entry not found
    lblStat.Caption = "Entry not found!"
    
End Sub
Sub find_last()
    Dim num As Integer
    Dim loc As Integer
    Dim i As Integer
    
    ' indicate entry not found yet
    loc = -1
    
    For i = 0 To NumEnts - 1
        num = lstList.ItemData(i)
        If num = KeyNum Then loc = i
    Next
    
    If loc < 0 Then
        lblStat.Caption = "Entry not found!"
    Else
        lblStat.Caption = "Entry found at location " & loc
        lstList.ListIndex = loc ' select entry
    End If
End Sub
Sub find_count()
    Dim num As Integer
    Dim count As Integer
    Dim i As Integer
    
    ' search for number
    For i = 0 To NumEnts - 1
        num = lstList.ItemData(i)
        If num = KeyNum Then count = count + 1
    Next
    
    lblStat.Caption = "Entry found " & count & " times"
    
End Sub
Sub find_list()
    Dim num As Integer
    Dim i As Integer
    
    ' search for number & make list
    lstFind.Clear   ' clear search result
    
    For i = 0 To NumEnts - 1
        num = lstList.ItemData(i)
        If num = KeyNum Then
            lstFind.AddItem "Loc " & i
            lstFind.ItemData(lstFind.NewIndex) = i
        End If
    Next
    
    num = lstFind.ListCount
    If num <= 0 Then
        lblStat.Caption = "Entry not found"
    Else
        lblStat.Caption = "Entry found " & num & " times"
    End If
End Sub

Private Sub lstFind_Click()
    Dim num As Integer
    
    ' get location for selected entry
    num = lstFind.ItemData(lstFind.ListIndex)
    If num <= 0 Then
        lblStat.Caption = "Invalid selection for list result!"
    Else
        lstList.ListIndex = num
    End If
End Sub

Private Sub lstList_Click()
    Dim num As Integer
    
    num = lstList.ListIndex
    If num >= 0 Then
        txtFind.Text = lstList.ItemData(num)
    End If
    
End Sub

