VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   3120
      TabIndex        =   10
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdUpd 
      Caption         =   "Update"
      Height          =   495
      Left            =   1800
      TabIndex        =   9
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   495
      Left            =   480
      TabIndex        =   7
      Top             =   1920
      Width           =   1215
   End
   Begin VB.TextBox txtLName 
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.TextBox txtFName 
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.TextBox txtID 
      Height          =   495
      Left            =   1800
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox lstList 
      Height          =   1620
      Left            =   3120
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblStat 
      Alignment       =   2  'Center
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   2520
      Width           =   4455
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Last Name"
      Height          =   495
      Left            =   480
      TabIndex        =   6
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "First Name"
      Height          =   495
      Left            =   480
      TabIndex        =   5
      Top             =   720
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ID"
      Height          =   495
      Left            =   480
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim FirstTime As Boolean
Dim Custs(MAXENTS) As Cust
Dim NumEnts As Integer


Private Sub cmdAdd_Click()
    add_entry
End Sub

Private Sub cmdClear_Click()
    clear_entry
End Sub

Private Sub cmdUpd_Click()
    upd_entry
End Sub

Private Sub Form_Activate()
    If FirstTime Then init_form
    
End Sub

Private Sub Form_Load()
    FirstTime = True
End Sub
Sub init_form()

End Sub
Sub add_entry()
    Dim str As String
    Dim ID As Integer
    Dim i As Integer
    
    ' validate entry
    
    ' make sure list isn't full
    If NumEnts >= MAXENTS Then
        lblStat.Caption = "Table Full"
        Exit Sub
    End If
    
    ' name fields can't be blank
    If Len(txtFName.Text) = 0 Or Len(txtLName.Text) = 0 Then
        lblStat.Caption = "Invalid name"
        Exit Sub
    End If
    
    ' id must be positive and unique
    ID = Val(txtID.Text)
    If ID <= 0 Then
        lblStat.Caption = "Invalid ID"
        Exit Sub
    End If
    'make sure ID is unique
    For i = 0 To NumEnts - 1
        If ID = lstList.ItemData(i) Then
            lblStat.Caption = "ID not Unique!"
            Exit Sub
        End If
    Next
    
    ' entry valid - add it
    Custs(NumEnts).ID = ID
    Custs(NumEnts).FName = txtFName.Text
    Custs(NumEnts).LName = txtLName.Text
    
    ' build index entry & add it
    str = txtLName.Text & ", " & txtFName.Text
    lstList.AddItem str
    lstList.ItemData(lstList.NewIndex) = NumEnts
    
    lblStat.Caption = "Entry added at location " & NumEnts
    NumEnts = NumEnts + 1   ' increment count of entries
    clear_entry
End Sub
Sub clear_entry()
    txtID.Text = ""
    txtLName.Text = ""
    txtFName.Text = ""
End Sub

Private Sub lstList_Click()
    display_ent
End Sub
Sub display_ent()
    Dim num As Integer
    Dim loc As Integer
    
    num = lstList.ListIndex ' current entry
    If num < 0 Then Exit Sub ' nothing selected
    loc = lstList.ItemData(num) ' location in array
    
    txtID.Text = Custs(loc).ID
    txtLName.Text = Custs(loc).LName
    txtFName.Text = Custs(loc).FName
    
    lblStat.Caption = "Entry at location " & loc
End Sub
Sub upd_entry()
    Dim num As Integer
    Dim loc As Integer
    Dim ID As Integer
    Dim i As Integer
    Dim str As String
    
    
    num = lstList.ListIndex     ' current entry
    If num < 0 Then Exit Sub    ' nothing selected
    loc = lstList.ItemData(num) ' location in array
    
    ID = Val(txtID.Text)
    If ID <= 0 Then
        lblStat.Caption = "Invalid ID"
        Exit Sub
    End If
    
    For i = 0 To NumEnts - 1
        If ID = Custs(i).ID And i <> loc Then
            lblStat.Caption = "ID not unique"
            Exit Sub
        End If
    Next
    
    If Len(txtLName.Text) = 0 Or Len(txtFName.Text) = 0 Then
        lblStat.Caption = "Invalid name"
        Exit Sub
    End If
    
    ' entry valid - do update
    Custs(loc).ID = ID
    Custs(loc).FName = txtFName.Text
    Custs(loc).LName = txtLName.Text
    
    ' remove from index & insert w/ new info
    lstList.RemoveItem (num)
    str = Custs(loc).LName & ", " & Custs(loc).FName
    lstList.AddItem str
    lstList.ItemData(lstList.NewIndex) = loc
    
End Sub
