/*
 * This is the header file for the getinfo program
 */

#define MAXENT 100
#define NAMESIZ 24

/* codes to indicate if add is valid */
#define ADD_OK 	0	/* add was fine (normal) */
#define ADD_BAD 1   /* invalid record */
#define ADD_DONE -1 /* all done adding */

struct cust
{
    int id;                 /* customer number */
    char lname[NAMESIZ];    /* last name of customer */
    char fname[NAMESIZ];    /* first name of customer */
    float bal;              /* balance of customer */
};

/* the next structure isn't used until random I/O */
struct index
{
    int id;                 /* customer number */
    long loc;               /* location in file */
};
