VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlg 
      Left            =   120
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   3120
      TabIndex        =   10
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdUpd 
      Caption         =   "Update"
      Height          =   495
      Left            =   1800
      TabIndex        =   9
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   495
      Left            =   480
      TabIndex        =   7
      Top             =   1920
      Width           =   1215
   End
   Begin VB.TextBox txtLName 
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.TextBox txtFName 
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.TextBox txtID 
      Height          =   495
      Left            =   1800
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox lstList 
      Height          =   1620
      Left            =   3120
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblStat 
      Alignment       =   2  'Center
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   2520
      Width           =   4455
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Last Name"
      Height          =   495
      Left            =   480
      TabIndex        =   6
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "First Name"
      Height          =   495
      Left            =   480
      TabIndex        =   5
      Top             =   720
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ID"
      Height          =   495
      Left            =   480
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuFileClose 
         Caption         =   "&Close"
      End
      Begin VB.Menu mnuFileBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim FirstTime As Boolean
Dim FileOpen As Boolean
Dim FileChanged As Boolean
Dim NumEnts As Integer
Dim FileName As String
Dim IndexName As String




Private Sub cmdAdd_Click()
    add_entry
End Sub

Private Sub cmdClear_Click()
    clear_entry
End Sub

Private Sub cmdUpd_Click()
    lstList.RemoveItem (lstList.ListIndex)
    add_entry
End Sub

Private Sub Form_Activate()
    If FirstTime Then init_form
    
End Sub

Private Sub Form_Load()
    FirstTime = True
End Sub
Sub init_form()
    dlg.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
    
End Sub
Sub add_entry()
    Dim str As String
    Dim ID As Integer
    Dim loc As Long
    Dim i As Integer
    
    ' validate entry
    
    ' name fields can't be blank
    If Len(txtFName.Text) = 0 Or Len(txtLName.Text) = 0 Then
        lblStat.Caption = "Invalid name"
        Exit Sub
    End If
    
    ' id must be positive and unique
    ID = Val(txtID.Text)
    If ID <= 0 Then
        lblStat.Caption = "Invalid ID"
        Exit Sub
    End If
    'make sure ID is unique
    'For i = 0 To NumEnts - 1
    '    loc = lstList.ItemData(i)
    '    If ID = Custs(loc).ID Then
    '        lblStat.Caption = "ID not Unique!"
    '        Exit Sub
    '    End If
    'Next
    
    ' entry valid - add it
    ' Close DataFN
    Open FileName For Append As #DataFN
    
    If lstList.ListCount > 0 Then
        ' file has data in it, go to end
        loc = LOF(DataFN)   ' go to end of file
    Else
        loc = 1
    End If
    Print #DataFN, ID & "|" & txtFName.Text & "|" & txtLName.Text
    
    ' now close and re-open for input
    Close DataFN
    FileChanged = True
    
    ' Open FileName For Input As #DataFN
    
    ' build index entry & add it
    str = txtLName.Text & ", " & txtFName.Text
    lstList.AddItem str
    lstList.ItemData(lstList.NewIndex) = loc
    
    lblStat.Caption = "Entry added at location " & loc

    clear_entry
End Sub
Sub clear_entry()
    txtID.Text = ""
    txtLName.Text = ""
    txtFName.Text = ""
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Dim ret As Integer
    
    ret = MsgBox("Are you sure?", vbYesNo, "Quitting Program")
    If ret <> vbYes Then
        Cancel = 1 ' cancel unload
    Else
        ' quitting - make sure files closed
        If FileChanged Then
            close_index
        End If
    End If
    
End Sub

Private Sub lstList_Click()
    display_ent
End Sub
Sub display_ent()
    Dim num As Integer
    Dim loc As Integer
    Dim s As String
    Dim flds() As String
    
    num = lstList.ListIndex ' current entry
    If num < 0 Then Exit Sub ' nothing selected
    loc = lstList.ItemData(num) ' location in array
    
    Open FileName For Input As #DataFN
    
    Seek #DataFN, loc
    
    Line Input #DataFN, s
    Close #DataFN
    
    flds = Split(s, "|")
    
    txtID.Text = flds(0)
    txtFName.Text = flds(1)
    txtLName.Text = flds(2)
    
    lblStat.Caption = "Entry at location " & loc
End Sub
Sub upd_entry()
    Dim num As Integer
    Dim loc As Integer
    Dim ID As Integer
    Dim i As Integer
    Dim str As String
    
    
    num = lstList.ListIndex     ' current entry
    If num < 0 Then Exit Sub    ' nothing selected
    loc = lstList.ItemData(num) ' location in array
    
    ID = Val(txtID.Text)
    If ID <= 0 Then
        lblStat.Caption = "Invalid ID"
        Exit Sub
    End If
    
    'For i = 0 To NumEnts - 1
    '    If ID = Custs(i).ID And i <> loc Then
    '        lblStat.Caption = "ID not unique"
    '        Exit Sub
    '    End If
    'Next
    
    If Len(txtLName.Text) = 0 Or Len(txtFName.Text) = 0 Then
        lblStat.Caption = "Invalid name"
        Exit Sub
    End If
    
    ' entry valid - do update
    'Custs(loc).ID = ID
    'Custs(loc).FName = txtFName.Text
    'Custs(loc).LName = txtLName.Text
    
    ' remove from index & insert w/ new info
    lstList.RemoveItem (num)
    str = Custs(loc).LName & ", " & Custs(loc).FName
    lstList.AddItem str
    lstList.ItemData(lstList.NewIndex) = loc
    
End Sub

Private Sub mnuFileClose_Click()
    close_index
End Sub

Private Sub mnuFileExit_Click()
    Unload Me   ' quit
End Sub

Private Sub mnuFileNew_Click()
    Dim s As String
    Dim n As Integer
    
    dlg.CancelError = True
    On Error GoTo errHandler
    
    dlg.DialogTitle = "Choose the name of a new data file"
    dlg.Filter = "Text Data File (*.txt)|*.txt"
    dlg.ShowSave
    FileName = dlg.FileName
    
    n = InStr(FileName, ".")
    If n > 0 Then
        s = Left(FileName, n) & "ndx"
    Else
        s = ""
    End If
    
    dlg.DialogTitle = "Choose the name of an index file"
    dlg.Filter = "Text Index File (*.ndx)|*.ndx"
    dlg.FileName = s
    dlg.ShowSave
    IndexName = dlg.FileName

    Open FileName For Output As #DataFN
    Open IndexName For Output As #IndexFN
    Print #IndexFN, FileName
    Close IndexFN
    Close DataFN

    FileOpen = True ' data file open
    
    Exit Sub
    
errHandler:
    Exit Sub
End Sub

Private Sub mnuFileOpen_Click()
    Dim s As String
    
    dlg.CancelError = True  ' cancel is an error
    On Error GoTo errHandler
    
    dlg.DialogTitle = "Select customer database index to open"
    dlg.Filter = "Text Index file (*.ndx)|*.ndx"
    dlg.ShowOpen
    s = dlg.FileName    ' file selected
    load_file (s)
    Exit Sub
    
errHandler:
    lblStat.Caption = "User cancelled Open"
    Exit Sub
    
End Sub
Sub load_file(FName As String)
    Dim s As String
    Dim flds() As String
    
    On Error GoTo errHandler
    
    Open FName For Input As #IndexFN
    Line Input #IndexFN, s
    Open s For Input As #DataFN
    IndexName = FName
    FileName = s
    
    Do While Not EOF(IndexFN)
        Line Input #IndexFN, s
        flds = Split(s, "|")
        If UBound(flds) <> 1 Then
            MsgBox "Invalid line (" & s & ")"
        Else
            lstList.AddItem flds(0)
            lstList.ItemData(lstList.NewIndex) = Val(flds(1))
        End If
    Loop
    
    ' FileOpen = True
    Close #IndexFN
    Close #DataFN
    
    Exit Sub
    
errHandler:
    lblStat.Caption = "Error reading file (" & FName & ")"
    Exit Sub
End Sub

Private Sub mnuFileSave_Click()
    save_index
    
End Sub
Sub store_file(FName As String)
    Dim s As String
    Dim i As Integer

    On Error GoTo errHandler
    
    Open FName For Output As #1
    
    For i = 0 To NumEnts - 1
        ' build output line
        s = Custs(i).ID & "|" & Custs(i).LName & "|" & Custs(i).FName
        Print #1, s
    Next
    
    ' Close #1
    
    Exit Sub
    
errHandler:
    lblStat.Caption = "I/O error when saving to file (" & FName & ")"
    Exit Sub

End Sub
Sub save_index()
    Dim i As Integer
    
    ' Close IndexFN
    Open IndexName For Output As #IndexFN ' rewind index file
    
    Print #IndexFN, FileName
    
    For i = 0 To lstList.ListCount - 1
        Print #IndexFN, lstList.List(i) & "|" & lstList.ItemData(i)
    Next
    Close #IndexFN
    ' Open IndexName For Input As #IndexFN
    
End Sub
Sub close_index()
    save_index
    'Close #DataFN
    'Close #IndexFN
    
End Sub
